// Learn cc.Class:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/class.html
//  - [English] http://docs.cocos2d-x.org/creator/manual/en/scripting/class.html
// Learn Attribute:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://docs.cocos2d-x.org/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] https://www.cocos2d-x.org/docs/creator/manual/en/scripting/life-cycle-callbacks.html

window.Global = {
    isInit: false,
    screenWidth: 750,
    screenHeight: 1334
};

cc.Class({
    extends: cc.Component,

    properties: {
        _didWatchedAd: false
    },

    // LIFE-CYCLE CALLBACKS:

    onLoad() {
        if (!Global.isInit) {
            //UI适配
            let canvasSize = cc.view.getCanvasSize(); //(1242.00, 2688.00)
            let visibleSize = cc.view.getVisibleSize(); //(750.00, 1334.00)
            if (canvasSize.width / canvasSize.height <= visibleSize.width / visibleSize.height) { //phone, fit width
                Global.screenHeight = canvasSize.height * visibleSize.width / canvasSize.width;
            } else { //pad, fit height
                Global.screenWidth = canvasSize.width * visibleSize.height / canvasSize.height;
            }

            //AdMob
            this.initAdmob();

            Global.isInit = true;
        }
    },

    initAdmob: function () {
        if ('undefined' == typeof sdkbox) {
            console.log('sdkbox is undefined');
            return;
        }

        if ('undefined' == typeof sdkbox.PluginAdMob) {
            console.log('sdkbox.PluginAdMob is undefined');
            return;
        }

        const self = this;
        sdkbox.PluginAdMob.setListener({
            adViewDidReceiveAd: function (name) {
                console.log('adViewDidReceiveAd name=' + name);

                if (name == "home") {
                    sdkbox.PluginAdMob.show(name);
                }
            },
            adViewDidFailToReceiveAdWithError: function (name, msg) {
                console.log('adViewDidFailToReceiveAdWithError name=' + name + ' msg=' + msg);
            },
            adViewWillPresentScreen: function (name) {
                console.log('adViewWillPresentScreen name=' + name);
            },
            adViewDidDismissScreen: function (name) {
                console.log('adViewDidDismissScreen name=' + name);
            },
            adViewWillDismissScreen: function (name) {
                console.log('adViewWillDismissScreen name=' + name);
            },
            adViewWillLeaveApplication: function (name) {
                console.log('adViewWillLeaveApplication name=' + name);
            },
            reward: function (name, currency, amount) {
                console.log('reward name=' + name + ' currency=' + currency + ' amount=' + amount);

                self._didWatchedAd = true;
            },
            adViewDidFailToPresentWithError: function (name, msg) {
                console.log('adViewDidFailToPresentWithError name=' + name + ' msg=' + msg);
            },
        });

        sdkbox.PluginAdMob.init();
    },

    start() {

    },

    // update (dt) {},
});
